package com.fetchFile;

import com.sendFile.protocol.FTP.FTPProtocol;
import com.sendFile.protocol.SSH.SSHProtocol;

public class FetchReportFile {
  String user;
  String password;
  String host;
  String local_folder_path;
  String remote_file_path;
  String transfer_protocol;
  String remote_report_pattern;
  int port;

  public FetchReportFile(
      String user,
      String password,
      String host,
      String local_folder_path,
      String remote_file_path,
      String transfer_protocol,
      int port,
      String remote_report_pattern) {
    this.user = user;
    this.password = password;
    this.host = host;
    this.local_folder_path = local_folder_path;
    this.remote_file_path = remote_file_path;
    this.transfer_protocol = transfer_protocol;
    this.port = port;
    this.remote_report_pattern = remote_report_pattern;
  }

  public void fetchFiles() {
    if (this.transfer_protocol.equals("SSH")) {
      SSHProtocol ssh =
          new SSHProtocol(
              this.user,
              this.password,
              this.host,
              this.port,
              this.local_folder_path,
              this.remote_file_path,
              "",
              "");
      ssh.fetchFileSSH(this.remote_report_pattern);
    } else if (this.transfer_protocol.equals("FTP")) {
      FTPProtocol ftp =
          new FTPProtocol(
              this.user,
              this.password,
              this.host,
              this.port,
              this.local_folder_path,
              this.remote_file_path,
              "",
              "");

      ftp.fetchFileFTP(this.remote_report_pattern);
    } else {

      System.out.println("Invalid TRANSFER_PROTOCOL. Must be one of FTP or SSH");
    }
  }
}