package com.sendFile;

import java.io.File;
import com.sendFile.protocol.FTP.FTPProtocol;
import com.sendFile.protocol.SSH.SSHProtocol;

public class SendLocalfile {
  String user;
  String password;
  String hostUcb;
  String hostNabard;
  String local_folder_path;
  String archive_path;
  String remote_file_path;
  String transfer_protocol;
  int port;

  public SendLocalfile(
      String user,
      String password,
      String hostUcb,
      String hostNabard,
      String local_folder_path,
      String remote_file_path,
      String transfer_protocol,
      int port,
      String archivePath) {
    this.user = user;
    this.password = password;
    this.hostUcb = hostUcb;
    this.hostNabard = hostNabard;
    this.local_folder_path = local_folder_path;
    this.remote_file_path = remote_file_path;
    this.transfer_protocol = transfer_protocol;
    this.port = port;
    this.archive_path = archivePath;
  }

  public void sendFiles() {
    File folder = new File(this.local_folder_path);
    File[] listOfFiles = folder.listFiles();

    for (File file : listOfFiles) {
      if (file.isFile()) {
        System.out.println("Going to send file: " + file.getAbsolutePath());
        String bankCode = file.getName().split("-")[0];
        String bankHost = "";
        if(bankCode.equals("0005") || bankCode.equals("0021")) {
            bankHost = hostNabard;
        } else {
            bankHost = hostUcb;
        }


        if (this.transfer_protocol.equals("SSH")) {

          SSHProtocol ssh =
              new SSHProtocol(
                  this.user,
                  this.password,
                  bankHost,
                  this.port,
                  file.getAbsolutePath(),
                  this.remote_file_path,
                  file.getName(),
                  this.archive_path);
          ssh.sendFileSSH();
        } else if (this.transfer_protocol.equals("FTP")) {

          FTPProtocol ftp =
              new FTPProtocol(
                  this.user,
                  this.password,
                  bankHost,
                  this.port,
                  file.getAbsolutePath(),
                  this.remote_file_path,
                  file.getName(),
                  this.archive_path);
          ftp.sendFileFTP();
        } else {

          System.out.println("Invalid TRANSFER_PROTOCOL. Must be one of FTP or SSH");
        }
      }
    }
  }
}
